;calculate data for first char
lcd_vline:	lds	YH,lcd_charline		;cline
		lds	YL,lcd_pixline		;PCC
		lds	XL,libmio_rampos_l
		lds	XH,libmio_rampos_h
		lds	tempreg1,libmio_color	;2 get color byte
		out	PORTC,tempreg1		;1
		push	tempreg4
		cpi	YH,1
		brcs	lcd_dline_e
		subi	YH,1
		cpi	YL,4
		brcc	lcd_dline
		ldi	YL,8			;1 8 bytes/char
		ld	ZL,X+			;2
		mul	ZL,YL			;2
		ldi	ZL,LOW(lcd_charset)	;1
		ldi	ZH,HIGH(lcd_charset)	;1
		add	ZL,r0			;1 add character offset
		adc	ZH,r1			;1
		add	ZL,YH			;1 add cline offset
		adc	ZH,const_0		;1
		ld	tempreg3,Z		;2
		ldi	tempreg4,lcd_cols	;1
		lds	tempreg2,libmio_color	;2 color for pixpause

lcd_vloop:	mov	tempreg1,tempreg2	;1 get color
		sbrc	tempreg3,4		;1 skip if pix is off
		swap	tempreg1		;1
		out	PORTC,tempreg1		;1 out pix 4

		ld	ZL,X+			;2 get next byte
		mov	tempreg1,tempreg2	;1
		sbrc	tempreg3,3		;1 skip if pix is not changed
		swap	tempreg1		;1
		ldi	ZH,HIGH(lcd_charset)	;1
		out	PORTC,tempreg1		;1 out pix 3

		mov	tempreg1,tempreg2	;1
		sbrc	tempreg3,2		;1 skip if pix is not changed
		swap	tempreg1		;1
		mul	ZL,YL			;2
		ldi	ZL,LOW(lcd_charset)	;1
		out	PORTC,tempreg1		;1 out pix 2

		mov	tempreg1,tempreg2	;1
		sbrc	tempreg3,1		;1 skip if pix is not changed
		swap	tempreg1		;1
		add	ZL,r0			;1 add character offset
		adc	ZH,r1			;1
		nop				;1
		out	PORTC,tempreg1		;1 out pix 1


		mov	tempreg1,tempreg2	;1
		sbrc	tempreg3,0		;1 skip if pix is not changed
		swap	tempreg1		;1
		add	ZL,YH			;1 add cline offset
		adc	ZH,const_0		;1
		nop				;1
		out	PORTC,tempreg1		;1 out pix 0

		ld	tempreg3,Z		;2
		ld	tempreg3,Z		;2
		ld	tempreg3,Z		;1
		out	PORTC,tempreg2		;1 out pixpause
		dec	tempreg4		;1 loop counter
		brne	lcd_vloop		;2/1

		ldi	tempreg2,1
lcd_dline_0:	dec	tempreg2
		brne	lcd_dline_0
		nop
		nop
		rjmp	lcd_nline

lcd_dline_e:	nop
		nop
		nop
lcd_dline:	ldi	tempreg2,172
lcd_dline_1:	dec	tempreg2
		nop
		nop
		brne	lcd_dline_1
		nop


lcd_nline:	pop	tempreg4
		lds	tempreg2,libmio_border	;2
		lds	YL,lcd_pixline
		lds	ZH,lcd_charline		;2 character line
		inc	YL
		cpi	YL,2
		out	PORTC,tempreg2		;1 out border
		brne	lcd_nline_1
		clr	YL
		inc	ZH
		cpi	ZH,9			;1 check
		brne	lcd_nline_1		;2 jump if not next line
		clr	ZH			;1 character line = 0
		lds	XL,libmio_rampos_l
		lds	XH,libmio_rampos_h
		adiw	XL,lcd_cols
		sts	libmio_rampos_l,XL	;2 new memory position
		sts	libmio_rampos_h,XH	;2 new memory position
lcd_nline_1:	sts	lcd_pixline,YL
		sts	lcd_charline,ZH		;2 new character line
		ret
