;################################################################################
;#										#
;# mode 7 engine 40x24 text							#
;# copyright (c) 2009-2010 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

.equ		vidmode_cols = 50
.equ		vidmode_rows = 24

.include	"/usr/local/include/chipbasic2/m644Pdef.inc"
.include	"/usr/local/include/chipbasic2/api_macros.inc"
.include	"/usr/local/include/chipbasic2/libdef.asm"
.include	"/usr/local/include/chipbasic2/definitions.asm"

.equ		libmio_ctable	= 0x7b00

.equ		vidmode_cline	= libmio_vram+1301
.equ		vidmode_pline	= libmio_vram+1302
.equ		vidmode_rampos_l	= libmio_vram+1303
.equ		vidmode_rampos_h	= libmio_vram+1304

.CSEG

.org	0x7200
;                   "......      N"
start:		.db "XRAM6424*50 N",0x13,0x81,0x00

;icon def
		.db 0xf2,0xf1,0xf1,0xf3
		.db 0xf0,"VT",0xf0
		.db 0xf4,0xf1,0xf1,0xf5

.org	0x720e
		rjmp	inex			;input ext
		rjmp	outex			;output ext
		rjmp	vidmode_start		;FKT 00
		rjmp	vidmode_init		;FKT 01 init
		rjmp	vidmode_clear		;FKT 02 clear screen
		rjmp	vidmode_char		;FKT 03 output char
		rjmp	vidmode_gxy		;FKT 04 set cursor
		rjmp	vidmode_plot		;FKT 05 plot
		rjmp	vidmode_newl		;FKT 06 NL
		rjmp	vidmode_vid		;FKT 07 video display
		rjmp	xmem_aread		;FKT 08 array read [7218]
		rjmp	xmem_awrite		;FKT 09 array write [7219]
		rjmp	xmem_rbyte		;FKT 0A r18=(X+) [721a]
		rjmp	xmem_wbyte		;FKT 0B (X+)=r18 [721b]
		rjmp	xmem_rword		;FKT 0C r18/r19=(X+) [721c]
		rjmp	xmem_wword		;FKT 0D (X+)=r18/r19 [721d]
		rjmp	xmem_check		;FKT 0E X=last memory cell
		rjmp	xmem_clear		;FKT 0F clear memory

;-------------------------------------------------------------------------------
; input expansion
;-------------------------------------------------------------------------------
inex:		ldi	ereg,40			;no IO driver
		ret

;-------------------------------------------------------------------------------
; output expansion
;-------------------------------------------------------------------------------
outex:		ldi	ereg,40			;no IO driver
		ret


.include 	"vout_m24x50.asm"
.include	"funct_m24x50.asm"
.include	"xram64.asm"
